<!DOCTYPE html>
<html lang="en-US">
<head>
	<title>Tabs</title>

	<meta charset="utf-8">

	<!-- Force latest available IE rendering engine and Chrome Frame (if installed) -->
	<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">

	<!-- Mobile Screen Resizing -->
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/normalize/8.0.1/normalize.min.css">
	<link href="https://fonts.googleapis.com/css?family=Cutive|Work+Sans" rel="stylesheet">


	<style type="text/css">
		/**
		 * Add box sizing to everything
		 * @link http://www.paulirish.com/2012/box-sizing-border-box-ftw/
		 */
		*,
		*:before,
		*:after {
			box-sizing: border-box;
		}

		/**
		 * Layout
		 */
		body {
			/* font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", "Roboto", "Oxygen", "Ubuntu", "Cantarell", "Fira Sans", "Droid Sans", "Helvetica Neue", sans-serif; */
			font-family: 'Work Sans', sans-serif; sans-serif;
			/* font-size: 112.5%; */
			margin-left: auto;
			margin-right: auto;
			max-width: 40em;
			width: 88%;
		}
		.tabs {
			display: grid;
			grid-template-columns: repeat(3, 1fr);
			border-bottom: 1px solid #aaa;
		  border-left: 1px solid #aaa;
		}
		.tabs div {
			padding: .6rem 0;
			border-top: 1px solid #aaa;
			border-right: 1px solid #aaa;
		}
		.tab-content {
			position: relative;
			/* border-top: 1px solid #aaa; */
		}
		.tabs div * {
			display: block;
			text-decoration: none;
			color: #333;
			text-align: center;
			transition: all .3s;
		}
		.tabs div *:hover {
			cursor: pointer;
			color: blue;
		}
		.tab-pane {
			position: absolute;
			top: 0;
			right: 0;
			bottom: 0;
			left: 0;
			opacity: 0;
			transition: all .3s;
		}
		.tab-pane.is-active {
			opacity: 1;
		}
	</style>
</head>
<body>

	<h1>Tabs</h1>

	<div class="tabs"></div>

	<div class="tab-content">
		<div class="tab-pane" id="spiderman">
			<h2>Spiderman</h2>
			<p>After being bitten by a radioactive spider at a science exhibit, Peter Parker "acquires the agility and proportionate strength of an arachnid." Along with super strength, Peter gains the ability to adhere to walls and ceilings.</p>
		</div>
		<div class="tab-pane" id="wonder-woman">
			<h2>Wonder Woman</h2>
			<p>Diana, aka Wonder Woman, is the daughter of Hippolyta and grows up on the Amazon island of Themyscira. After American pilot and spy Steve Trevor crashes offshore of the island and is rescued by her, he tells the Amazons about the ongoing World War.</p>
		</div>
		<div class="tab-pane" id="wolverine">
			<h2>Wolverine</h2>
			<p>Wolverine is a mutant and member of the X-Men, who possesses animal-keen senses, enhanced physical capabilities, powerful regenerative ability known as a healing factor, and three retractable claws in each hand.</p>
		</div>
		<div class="tab-pane" id="lorem">
			<h2>Lorem</h2>
			<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Optio hic aperiam sunt mollitia, vero! Quod eligendi, voluptatem. Adipisci recusandae, neque, quo laudantium obcaecati consequuntur dolorum. Minima vel nisi harum odit.</p>
		</div>

		<div class="tab-pane" id="ipsum">
			<h2>Ipsum</h2>
			<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Optio hic aperiam sunt mollitia, vero! Quod eligendi, voluptatem. Adipisci recusandae, neque, quo laudantium obcaecati consequuntur dolorum. Minima vel nisi harum odit.</p>
		</div>
		<div class="tab-pane" id="dolor">
			<h2>Dolor</h2>
			<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Optio hic aperiam sunt mollitia, vero! Quod eligendi, voluptatem. Adipisci recusandae, neque, quo laudantium obcaecati consequuntur dolorum. Minima vel nisi harum odit.</p>
		</div>
	</div>

	<script crossorigin="anonymous" src="https://polyfill.io/v3/polyfill.min.js?features=default"></script>
	<script>
		const ToggleTabs = (function () {

			'use strict';

			/**
			 * Setup Constructor
			 */

			let Constructor = function () {

				//
				// Variables
				//

				let publicAPIs = {};

				let settings, panes, headings, tabs;

				let defaults = {
					links: 				true,
					heading: 			'h2',
					pane: 				'.tab-pane',
					activeClass:  'is-active'
				}

				/**
				 * [description]
				 * @param  {[type]} elem [description]
				 * @return {[type]}      [description]
				 */

				const getID = function (elem) {
					// If the element doesn't have an ID, create one
					if (!elem.id) {
						elem.id = elem.textContent.replace(new RegExp(' ', 'g'), '-');
					}
					// Get the element ID
					return elem.id.toLowerCase();
				};

				/**
				 * Create a new tab when a new pane is created
				 * @return {Array} List of tab toggles
				 */

				const createTabs = function () {
					// Create array of tabs
					let tabItems = Array.from(headings).map(heading => {
						if (settings.links) {
							return '<div><a href="#' + getID(heading) + '">' + heading.textContent + '</a></div>'
						}
						return '<div><span data-id="' + getID(heading) + '">' + heading.textContent + '</span></div>'

					})

					// Inject tabs
					if (tabs && tabItems.length > 0) {
						tabs.innerHTML = tabItems.join('')
					}
				}

				/**
				 * If there is no location hash on page load set one
				 * @return {[type]} [description]
				 */

				publicAPIs.setHash = function () {
					if (!location.hash) {
						location.hash = panes[0].id
					}
				}

				/**
				 * Toggle the active pane based on location hash
				 * @return {[type]} [description]
				 */

				publicAPIs.toggleContent = function () {

					// Hide content
					panes.forEach(pane => {
						if (pane.id !== location.hash && pane.classList.contains(settings.activeClass)) {
							pane.classList.remove(settings.activeClass)
						}
					})

					// Show Content
					document.querySelector(location.hash).classList.add(settings.activeClass);
				}


				/**
				 * Event listeners which toggle active panes
				 * @return {[type]} [description]
				 */

				publicAPIs.updateHashListener = function () {

					// Check for trigger [data-id] attribute on click
					document.addEventListener('click', function(e) {
						if (e.target.matches('[data-id]')) {
							location.hash = '#' + e.target.dataset.id
						} else {
							return;
						}
					});

					// Hide and show tab content on hash change
					window.addEventListener('hashchange', publicAPIs.toggleContent, false);
				}

				/**
				 * Initializes public methods
				 * @param  {[type]} options [description]
				 * @return {[type]}         [description]
				 */

				publicAPIs.init = function (options) {

					// Merge user options into defaults
					settings = Object.assign({}, defaults, options);

					// Cache defaults
					tabs = document.querySelector('.tabs');

					panes = document.querySelectorAll(settings.pane);

					headings = document.querySelectorAll(settings.heading);

					// Initializes tab creation
					createTabs()

					// Sets location hash if none exists
					publicAPIs.setHash()

					// Show active pane on page load
					publicAPIs.toggleContent()

					// Show pane on hash change
					publicAPIs.updateHashListener()

				}

				//
				// Return Public Methods
				//

				return publicAPIs;

			}

			//
			// Return Constructor
			//

			return Constructor;
		})();

		let toggle = new ToggleTabs();
		// Using settings
		toggle.init({
			links:  false
		})

		// let toggleDefault = new ToggleTabs();
		// // Using defaults
		// toggleDefault.init()
	</script>

</body>
</html>
